﻿using System;
using System.Collections.ObjectModel;
using System.Globalization;
using System.Linq;
using System.Windows.Data;
using InfragisticsExampleWithListInsteadOfObservableCollection.Model;
using InfragisticsExampleWithListInsteadOfObservableCollection.ViewModel;

namespace InfragisticsExampleWithListInsteadOfObservableCollection.Converters
{
    public class GenderObjectToGenderViewModelConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
        { {
            var gender = value as GenderObject;
            var collectionSource = parameter as CollectionViewSource;
            var genderCollection = collectionSource.Source as ObservableCollection<GenderViewModel>;
            var genderVm = genderCollection?.FirstOrDefault(c => c.Id == gender?.Id);
            return genderVm;
        }}

        public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
        {
            if (!(value is GenderViewModel genderVm)) return null;

            return genderVm.Gender;
        }
    }
}
