﻿using System.Collections.Generic;
using System.ComponentModel;
using System.Runtime.CompilerServices;
using InfragisticsExampleWithListInsteadOfObservableCollection.Annotations;

namespace InfragisticsExampleWithListInsteadOfObservableCollection.Model
{
    public class ClassObject : INotifyPropertyChanged
    {
        private string _name;
        private string _id;
        private List<StudentObject> _students;

        public string Name
        {
            get => _name;
            set
            {
                if(_name == value) return;
                _name = value;
                OnPropertyChanged(nameof(Name));
            }
        }
        public string Id
        {
            get => _id;
            set
            {
                if(_id == value)return;
                _id = value;
                OnPropertyChanged(nameof(Id));
            }
        }

        public List<StudentObject> Students
        {
            get => _students;
            set
            {
                _students = value;
                OnPropertyChanged(nameof(Students));
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        [NotifyPropertyChangedInvocator]
        protected virtual void OnPropertyChanged([CallerMemberName] string propertyName = null)
        {
            PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(propertyName));  
        }
    }
}
