﻿using System.ComponentModel;
using System.Runtime.CompilerServices;
using InfragisticsExampleWithListInsteadOfObservableCollection.Annotations;

namespace InfragisticsExampleWithListInsteadOfObservableCollection.Model
{
    public class GenderObject : INotifyPropertyChanged
    {
        private int _id;
        private string _name;

        public int Id
        {
            get => _id;
            set
            {
                if(_id == value)return;
                _id = value;
                OnPropertyChanged(nameof(Id));
            }
        }
        public string Name
        {
            get => _name;
            set
            {
                if(_name == value)return;
                _name = value;
                OnPropertyChanged(nameof(Name));
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        [NotifyPropertyChangedInvocator]
        protected virtual void OnPropertyChanged([CallerMemberName] string propertyName = null)
        {
            PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(propertyName));
        }
    }
}
