﻿using System.ComponentModel;
using System.Runtime.CompilerServices;
using InfragisticsExampleWithListInsteadOfObservableCollection.Annotations;

namespace InfragisticsExampleWithListInsteadOfObservableCollection.Model
{
    public class StudentObject : INotifyPropertyChanged
    {
        private string _name;
        private GenderObject _gender;
        private int _age;
        private int _id;

        public string Name
        {
            get => _name;
            set
            {
                if (_name == value) return;
                _name = value;
                OnPropertyChanged(nameof(Name));
            }
        }
        public GenderObject Gender
        {
            get => _gender;
            set
            {
                _gender = value;
                OnPropertyChanged(nameof(Gender));
            }
        }
        public int Age
        {
            get => _age;
            set
            {
                if (_age == value) return;
                _age = value;
                OnPropertyChanged(nameof(Age));
            }
        }
        public int Id
        {
            get => _id;
            set
            {
                if (_id == value) return;
                _id = value;
                OnPropertyChanged(nameof(Id));
            }
        }

        public StudentObject(int id,int age, string name, GenderObject gender)
        {
            Id = id;
            Age = age;
            Name = name;
            Gender = gender;
        }

        public event PropertyChangedEventHandler PropertyChanged;

        [NotifyPropertyChangedInvocator]
        protected virtual void OnPropertyChanged([CallerMemberName] string propertyName = null)
        {
            PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(propertyName));
        }
    }
}
