﻿using System.ComponentModel;
using System.Runtime.CompilerServices;
using InfragisticsExampleWithListInsteadOfObservableCollection.Annotations;
using InfragisticsExampleWithListInsteadOfObservableCollection.Model;

namespace InfragisticsExampleWithListInsteadOfObservableCollection.ViewModel
{
    public class GenderViewModel : INotifyPropertyChanged
    {
        public GenderObject Gender
		{
			get;
			set;
		}

        public int Id
        {
            get => Gender.Id;
            set
            {
                Gender.Id = value;
                OnPropertyChanged(nameof(Id));
            }
        }
        public string Name
        {
            get => Gender.Name;
            set
            {
                Gender.Name = value;
                OnPropertyChanged(nameof(Name));
            }
        }

        public GenderViewModel(GenderObject gender)
        {
            Gender = gender;
        }

        public event PropertyChangedEventHandler PropertyChanged;

        [NotifyPropertyChangedInvocator]
        protected virtual void OnPropertyChanged([CallerMemberName] string propertyName = null)
        {
            PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(propertyName));
        }
    }
}
